<?php
/*
Plugin Name: Comment Hilite
Version: 1.1
Plugin URI: http://rebelpixel.com/projects/rp-comment-hilite/
Description: Plugin for highlighting noteworthy comments.
Author: Markku Seguerra
Author URI: http://rebelpixel.com/
*/

if (!function_exists('rp_is_comment_hilite')) {
    function rp_is_comment_hilite()
    {
        global $post, $post_meta_cache, $comment;

        if (isset($post_meta_cache[$post->ID]['comment-hilite'][0])  && strlen($post_meta_cache[$post->ID]['comment-hilite'][0]) > 0) {
            $n = trim($post_meta_cache[$post->ID]['comment-hilite'][0]);
            $n = explode(',', $n);
            $i = 0;

            for ($i=0; $i < count($n); $i++) {
                $n[$i] = trim($n[$i]);
                $n[$i] = intval($n[$i]);
            }
            if (in_array($comment->comment_ID, $n)) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
}


if (!function_exists('rp_comment_hilite_link')) {
    function rp_comment_hilite_link($link = 'Hilite This', $before = '', $after = '') {
        global $user_ID, $post, $comment;
        if (!function_exists('user_can_edit_post_comments')) {
            return;
        }

        get_currentuserinfo();

        if (!user_can_edit_post_comments($user_ID, $post->ID)) {
            return;
        }


        $location = get_settings('siteurl') . "/wp-admin/admin.php?page=rp-plugin-comment-hilite.php&amp;action=hilite&amp;post=$post->ID&amp;comment=$comment->comment_ID";
        echo "$before <a href='$location'>$link</a> $after";

    
    }
}






/**************----------------  STANDALONE SECTION  ---------------**************/
// Thanks to Kitten's Spaminator I can now write a WP-1.5 plugin! :)


if (function_exists('is_plugin_page') && is_plugin_page()) {


    function rp_add_comment_hilite()
    {
	    global $wpdb;

        if (  $_GET['action'] = 'hilite' && isset($_GET['post']) && isset($_GET['comment'])  ) {
            $post->ID = intval($_GET['post']);
            $comment->comment_ID = intval($_GET['comment']);

            if ($metadata = has_meta($post->ID)) {

                $curr_value = '';
                for ($i=0; $i < count($metadata); $i++) {
                    if ($metadata[$i]['meta_key'] == 'comment-hilite') {
                        if (strlen($curr_value) > 0) {
                            $curr_value = $curr_value.','.$metadata[$i]['meta_value'];
                        } else {
                            $curr_value = $curr_value.$metadata[$i]['meta_value'];
                        }
                        $match[] = $metadata[$i]['meta_id'];
                    }
                }
            }

            if (count($match) > 0) {
                $n = trim($curr_value);
                $n = explode(',', $n);

                for ($i=0; $i < count($n); $i++) {
                    $n[$i] = trim($n[$i]);
                    $n[$i] = intval($n[$i]);
                }

                if (in_array($comment->comment_ID, $n)) {
                    $message = 'Comment already highlighted.';
                } else {
                    $message = 'Comment highlighted.';
                    $n[] = $comment->comment_ID;
                }

                sort($n);
                $n = implode(',', $n);
                update_meta($match[0], 'comment-hilite', $n);

                if (count($match) > 1) {
                    for ($i=1; $i < count($match); $i++) {
                        delete_meta($match[$i]);
                    }
                }
            } else {
                
                $wpdb->query("
                        INSERT INTO $wpdb->postmeta 
                        (post_id,meta_key,meta_value) 
                        VALUES ('$post->ID','comment-hilite','$comment->comment_ID')
                    ");
                $message = 'Comment highlighted.';

            }

        }
        return $message;
    }

    $message = rp_add_comment_hilite();


    if (strlen($message) > 0) {
        echo "<div class='updated'><p>$message</p></div>";
    }


 ?>


	<div class="wrap">
	<h2>Comment Hilite</h2>
	<p>Plugin for highlighting noteworthy comments. More information at the
    <a href="ttp://rebelpixel.com/projects/rp-comment-hilite/">project's page</a>.
    </p>




	</div>
<?php }
else {
    function rp_comment_hilite_admin_menu() {
        add_management_page('Comment Hilite', 'Comment Hilite', 5, 'rp-plugin-comment-hilite.php'); // adds to the Manage menu
    }
}
add_action('admin_menu', 'rp_comment_hilite_admin_menu'); // runs the function to add those menus

/**************--------------  END STANDALONE SECTION  -------------**************/



?>